//This was all done by me, SpeedyM! ;)
local XSPINCHAR = 0
local FlyHeight = 0
local SpinDuration = 0
local burstrings = 15
local rbrandom = 1
local custom1avail

addHook("ThinkFrame", function()
	for player in players.iterate do

		if not (player.XSPINCHAR or player.FlyHeight or player.SpinDuration or player.rbrandom) then
			player.XSPINCHAR = 0
			player.FlyHeight = 0
			player.SpinDuration = 0
			player.rbrandom = 1
		end

    end
end)

freeslot("sfx_xspin", "sfx_xspin2", "sfx_xspin3")

local function xspinreset(player)
	player.mo.state = S_PLAY_FALL
	player.pflags = $1|PF_JUMPED
	player.XSPINCHAR = 0
	player.FlyHeight = 0
	player.SpinDuration = 0
	S_FadeMusic(100, 1*MUSICRATE, player)
	player.normalspeed = skins[player.mo.skin].normalspeed
	if S_SoundPlaying(player.mo, sfx_xspin) or S_SoundPlaying(player.mo, sfx_xspin2) or S_SoundPlaying(player.mo, sfx_xspin3)
		S_StopSoundByID(player.mo, sfx_xspin) 
		S_StopSoundByID(player.mo, sfx_xspin2) 
		S_StopSoundByID(player.mo, sfx_xspin3)
	end
end

addHook("PlayerThink", function(player)
	if player.rings >= burstrings
	and player.mo.skin == "sonic"
	and player.XSPINCHAR == 17
		player.pflags = $1|PF_THOKKED & ~PF_JUMPED
		if not player.speed == 0
			P_InstaThrust(player.mo, player.mo.angle, 75*FRACUNIT)
		end
		if player.rbrandom == 1
			S_StartSound(player.mo, sfx_xspin)
		end
		if player.rbrandom == 2
			S_StartSound(player.mo, sfx_s3kb6)
			S_StartSound(player.mo, sfx_xspin2)
		end
		if player.rbrandom == 3
			S_StartSound(player.mo, sfx_s3kb6)
			S_StartSound(player.mo, sfx_xspin3)
		end
		P_GivePlayerRings(player, -burstrings)
		if P_IsObjectOnGround(player.mo)
			player.FlyHeight = 10
		end
		player.mo.state = S_PLAY_SPINDASH
		local xactive = P_SpawnGhostMobj(player.mo)
		xactive.colorized = true
		xactive.color = SKINCOLOR_WHITE
		xactive.blendmode = AST_ADD
		xactive.scale = player.mo.scale*5
		xactive.destscale = player.mo.scale
		xactive.scalespeed = $-5*FRACUNIT
		if player.mo.momz >= 0*FRACUNIT
			player.FlyHeight = player.mo.momz/FRACUNIT-FRACUNIT
		else
			player.FlyHeight = 0
		end
		player.XSPINCHAR = 18
	end
	if player.XSPINCHAR == 18
	and player.mo.skin == "sonic"
		player.mo.state = S_PLAY_SPINDASH
		local DashTrail = P_SpawnGhostMobj(player.mo)
		DashTrail.fuse = 10
		DashTrail.blendmode = AST_ADD
		DashTrail.scale = player.mo.scale+10000
		if player.speed >= 80*FRACUNIT
			local DashTrail2 = P_SpawnGhostMobj(player.mo)
			DashTrail2.fuse = 7
			DashTrail2.color = SKINCOLOR_WHITE
			DashTrail2.blendmode = AST_ADD
			DashTrail2.scale = player.mo.scale+20000
			DashTrail2.translucency = 0
		end
		player.mo.momz = player.FlyHeight*FRACUNIT
		S_FadeMusic(0, 500, player)
		player.SpinDuration = $ + 1
		player.normalspeed = 100*FRACUNIT
		player.powers[pw_strong] = STR_TWINSPIN|STR_GUARD|STR_ANIM
		if (player.cmd.buttons & BT_JUMP)
			player.FlyHeight = $ + 2
		end
		if (player.cmd.buttons & BT_SPIN)
			player.FlyHeight = $ - 3
		end
		if P_IsObjectOnGround(player.mo)
			xspinreset(player)
		end
		if not (player.cmd.buttons & BT_CUSTOM1) then
			custom1avail = true
		end
		if (player.cmd.buttons & BT_CUSTOM1)
		and not custom1avail == false then
			S_StartSound(player.mo, sfx_s23c)
			local xdash = P_SpawnGhostMobj(player.mo)
			xdash.colorized = true
			xdash.color = SKINCOLOR_WHITE
			xdash.blendmode = AST_ADD
			xdash.scale = player.mo.scale*2
			xdash.destscale = player.mo.scale
			xdash.scalespeed = $-1*FRACUNIT
			P_InstaThrust(player.mo, player.mo.angle, 80*FRACUNIT)
			if player.powers[pw_super]
				P_InstaThrust(player.mo, player.mo.angle, 132*FRACUNIT)
			end
			custom1avail = false
		end
		//Cancels (Most of it)
		if P_PlayerInPain(player)
			xspinreset(player)
			return P_PlayerInPain(player)
		elseif P_CheckDeathPitCollide(player.mo)
			xspinreset(player)
			player.mo.state = S_PLAY_PAIN
		end
	end
	if (player.cmd.buttons & BT_TOSSFLAG)
	and player.mo.skin == "sonic"
	and player.rings >= burstrings
	and not (player.pflags & PF_THOKKED)
		player.XSPINCHAR = $ + 1
		player.rbrandom = $ + 1
		if player.rbrandom >= 4
			player.rbrandom = 1
		end
		if player.XSPINCHAR > 18
			xspinreset(player)
		end
		if P_IsObjectOnGround(player.mo)
			S_StartSound(player.mo, sfx_s3k62)
			player.mo.momz = 10*FRACUNIT
			player.mo.state = S_PLAY_ROLL
			player.pflags = $1|PF_JUMPED
		end
		local CHARGSPIN = P_SpawnGhostMobj(player.mo)
		CHARGSPIN.color = SKINCOLOR_WHITE
		CHARGSPIN.blendmode = AST_ADD
		CHARGSPIN.renderflags = CHARGSPIN.renderflags|FF_FULLBRIGHT
	end
	if player.SpinDuration == 4*TICRATE // Stops The Ability When SpinDuration Cap was reached
		xspinreset(player)
	end
end)

// Commands Section
COM_AddCommand("xspinrings", function(player, amount)
	local administrator = IsPlayerAdmin(player)
	if (administrator == true or player == server) then
		if not amount then
			CONS_Printf(player, "Type how many rings you need to use the ring burst.")
			return
		end
	end
	if amount and (administrator == true or player == server) then
		burstrings = tonumber(amount)
		if burstrings == 1
			print(player, "Ring burst requirement is now set to "..burstrings.." ring.")
			return
		end
		print(player, "Ring burst requirement is now set to "..burstrings.." rings.")
	elseif not player.mo
		CONS_Printf(player, "You must be in a game first.")
		return
	else
		CONS_Printf(player, "Sorry. You must be the server or an admin to do so.")
		return
	end
end)

addHook("NetVars", function(net)
	burstrings = net(burstrings)
end)